#include "userprog/syscall.h"
#include <stdio.h>
#include <syscall-nr.h>
#include "threads/interrupt.h"
#include "threads/thread.h"
#include "devices/shutdown.h"

static void syscall_handler (struct intr_frame *);
void syscall_exit(int status);
void syscall_halt(void);

void
syscall_init (void) 
{
  intr_register_int (0x30, 3, INTR_ON, syscall_handler, "syscall");
}


static void
syscall_handler (struct intr_frame *f)
{
  printf ("system call!\n");
  int sys_code = *(int*)f->esp;

  printf("System call number: %d\n", sys_code);

  switch(sys_code) {

    case SYS_EXIT:
      printf("Running SYS_EXIT\n");
      //syscall_exit();
      break;

    case SYS_HALT:
      printf("Running SYS_HALT\n");
      syscall_halt();
      break;

    default:
      printf("Unknown Syscall number\n");
      break;
  }

  thread_exit ();
}


/* System Call Implementations*/

void syscall_exit(int status);

void syscall_halt()
{
  shutdown_power_off();
}
